# coding: utf-8

"""
    Auth - Application API

    Auth manages access policies for services that need access policies management for their clients. Auth also issues temporary credentials for the services' clients and validates them for the services  # noqa: E501

    OpenAPI spec version: 1.0.2
    Contact: refael@akeyless-security.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six


class GetUserReplyObj(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'access_expires': 'int',
        'account_id': 'str',
        'cidr_whitelist': 'str',
        'user_name': 'str',
        'user_policy_id': 'str',
        'user_roles': 'list[str]'
    }

    attribute_map = {
        'access_expires': 'access_expires',
        'account_id': 'account_id',
        'cidr_whitelist': 'cidr_whitelist',
        'user_name': 'user_name',
        'user_policy_id': 'user_policy_id',
        'user_roles': 'user_roles'
    }

    def __init__(self, access_expires=None, account_id=None, cidr_whitelist=None, user_name=None, user_policy_id=None, user_roles=None):  # noqa: E501
        """GetUserReplyObj - a model defined in Swagger"""  # noqa: E501

        self._access_expires = None
        self._account_id = None
        self._cidr_whitelist = None
        self._user_name = None
        self._user_policy_id = None
        self._user_roles = None
        self.discriminator = None

        if access_expires is not None:
            self.access_expires = access_expires
        if account_id is not None:
            self.account_id = account_id
        if cidr_whitelist is not None:
            self.cidr_whitelist = cidr_whitelist
        if user_name is not None:
            self.user_name = user_name
        if user_policy_id is not None:
            self.user_policy_id = user_policy_id
        if user_roles is not None:
            self.user_roles = user_roles

    @property
    def access_expires(self):
        """Gets the access_expires of this GetUserReplyObj.  # noqa: E501


        :return: The access_expires of this GetUserReplyObj.  # noqa: E501
        :rtype: int
        """
        return self._access_expires

    @access_expires.setter
    def access_expires(self, access_expires):
        """Sets the access_expires of this GetUserReplyObj.


        :param access_expires: The access_expires of this GetUserReplyObj.  # noqa: E501
        :type: int
        """

        self._access_expires = access_expires

    @property
    def account_id(self):
        """Gets the account_id of this GetUserReplyObj.  # noqa: E501


        :return: The account_id of this GetUserReplyObj.  # noqa: E501
        :rtype: str
        """
        return self._account_id

    @account_id.setter
    def account_id(self, account_id):
        """Sets the account_id of this GetUserReplyObj.


        :param account_id: The account_id of this GetUserReplyObj.  # noqa: E501
        :type: str
        """

        self._account_id = account_id

    @property
    def cidr_whitelist(self):
        """Gets the cidr_whitelist of this GetUserReplyObj.  # noqa: E501


        :return: The cidr_whitelist of this GetUserReplyObj.  # noqa: E501
        :rtype: str
        """
        return self._cidr_whitelist

    @cidr_whitelist.setter
    def cidr_whitelist(self, cidr_whitelist):
        """Sets the cidr_whitelist of this GetUserReplyObj.


        :param cidr_whitelist: The cidr_whitelist of this GetUserReplyObj.  # noqa: E501
        :type: str
        """

        self._cidr_whitelist = cidr_whitelist

    @property
    def user_name(self):
        """Gets the user_name of this GetUserReplyObj.  # noqa: E501


        :return: The user_name of this GetUserReplyObj.  # noqa: E501
        :rtype: str
        """
        return self._user_name

    @user_name.setter
    def user_name(self, user_name):
        """Sets the user_name of this GetUserReplyObj.


        :param user_name: The user_name of this GetUserReplyObj.  # noqa: E501
        :type: str
        """

        self._user_name = user_name

    @property
    def user_policy_id(self):
        """Gets the user_policy_id of this GetUserReplyObj.  # noqa: E501


        :return: The user_policy_id of this GetUserReplyObj.  # noqa: E501
        :rtype: str
        """
        return self._user_policy_id

    @user_policy_id.setter
    def user_policy_id(self, user_policy_id):
        """Sets the user_policy_id of this GetUserReplyObj.


        :param user_policy_id: The user_policy_id of this GetUserReplyObj.  # noqa: E501
        :type: str
        """

        self._user_policy_id = user_policy_id

    @property
    def user_roles(self):
        """Gets the user_roles of this GetUserReplyObj.  # noqa: E501


        :return: The user_roles of this GetUserReplyObj.  # noqa: E501
        :rtype: list[str]
        """
        return self._user_roles

    @user_roles.setter
    def user_roles(self, user_roles):
        """Sets the user_roles of this GetUserReplyObj.


        :param user_roles: The user_roles of this GetUserReplyObj.  # noqa: E501
        :type: list[str]
        """

        self._user_roles = user_roles

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, GetUserReplyObj):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
